//
//  POSTUpload.h
//  POSTUpload
//
//  Created by Gary Fielke on 27/11/05.
//  Copyright 2005 Holocore. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface POSTUpload : NSObject {

	CFHTTPMessageRef	req;
	CFReadStreamRef		httpReqStream;
	CFReadStreamRef		fileReadStream;
	
	NSMutableData		*responseData;
	NSTimer				*progEventTimer;
	
	SInt64				bodySize;
	SInt64				fileSize;
	SInt64				smallFileProgressBytes;
	SInt64				initialProgressVal;
	long				progressBytes;
	long				lastProgressBytes;
	NSTimeInterval		progressEventInterval;
	double				uploadRate;
	
	NSTimer				*uploadRateTimer;
	NSTimeInterval		timeIntervalFromStart;
	NSTimeInterval		startTime;
	SInt64				firstBytesWritten;		// ie send buffer size roughly
	BOOL				bodySizeIsLessThanBuffer;
	NSString			*bodyFilePath;	// temp file
	
	NSString			*cookieStr;
}

+(id)initPostUpload;

-(void)setProgressEventInterval:(NSTimeInterval)newProgressEventInterval;

-(NSString*)MIMETypeForFile:(NSString*)fpath;

-(BOOL)doPostWithURL:(NSString*)urlString 
		userAgentString:(NSString*)userAgentString 
		fieldValuePairs:(NSArray*)fieldValues 
		filePath:(NSString*)fpath
		headerValuePairs:(NSArray*)headerValues;
		
-(NSString*)doSimplePostWithURL:(NSString*)urlString 
				userAgentString:(NSString*)userAgentString 
				fieldValuePairs:(NSArray*)fieldValues 
				postEncoding:(NSString*)postEncoding
				headerValuePairs:(NSArray*)headerValues;
				
-(SInt64)getPOSTProgress;
-(void)cancelUpload;
-(NSString*)getSentCookies:(NSString*)urlStr;


// additions Apr 06
-(NSString*)md5FromString:(NSString*)inString;
-(NSArray*)genericPasswordByServiceName:(NSString*)serviceName; // accountName:(NSString*)accountName;
-(void)addGenericPassword:(NSString*)password byServiceName:(NSString*)serviceName accountName:(NSString*)accountName oldServiceName:(NSString*)oldServiceName;
-(void)deleteGenericPasswordFromServiceName:(NSString*)serviceName;

@end
